#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int a[2*(n-1)];
    int br=0;
    for(int i=0; i<2*(n-1); i++) cin>>a[i];
    for(int i=0; i<2*(n-1); i=i+2)
    {
        if(a[i]+1==a[i+1]) br++;
    }
    if(br==n-1)
    {
        if(n==4) cout<<1;
        else if (n % 2 == 0) cout<<n-3;
        else cout<<n-2;
    }
    return 0;
}